package de.hhu.phil.smt.ibm;

import java.io.FileNotFoundException;
import java.io.IOException;

/*
 * Author: kaeshammer@phil.uni-duesseldorf.de
 * 
 * Class für Uebung 4 of the course Statistische Maschinelle Übersetzung 2013 
 * at HHU
 */
public class Uebung4 {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// First, try with the toy data. When everything works as expected,
		// use the Europarl data (5000 sentence pairs).
		
		// input file names;
		String fileD = "data/toy.de";
		String fileE = "data/toy.en";
		//String fileD = "data/europarl-v7.de-en.30.h5000.de";
		//String fileE = "data/europarl-v7.de-en.30.h5000.en";
		
		// output file names
		String fileOut = "out/toy.ttable";
		String fileAlign = "out/toy.align";
		//String fileOut = "out/europarl-v7.de-en.30.h5000.ttable";
		//String fileAlign = "out/europarl-v7.de-en.30.h5000.align";
		
		try {
			// Create lexical translation model for "translating" from German 
			// (source) to English (target) -> P(e|d). 
			// Alignments will thus go from English words to German words.
			System.out.println("IBM Model 1 - Training ...");
			System.out.println("Source file (German): " + fileD);
			System.out.println("Target file (English): " + fileE);
			
			int iterations = 15;
			IBMModel1 m1 = new IBMModel1(fileD, fileE, iterations);
			
			System.out.println();
			
			// Print the lexical translation model to a file
			m1.writeTransProbTable2File(fileOut);
			
			// Print the most probable alignments of the training data to a file
			m1.writeMostProbableAlignments2File(fileAlign);
			
			System.out.println("Finished.");
			System.out.println("The lexical translation model is in " + fileOut + ".");
			System.out.println("The alignments are in " + fileAlign + ".");
			
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}

	}

}
