package de.hhu.phil.smt.lm;

import java.io.FileNotFoundException;

/*
 * Author: kaeshammer@uni-duesseldorf.de
 * 
 * Language Model interface
 */
public interface LanguageModel {
	
	/*
	 * e.g. 2 for bigram
	 */
	abstract int order(); 
	
	/*
	 * Probability of w given history h
	 */
	abstract double getProb(String h, String w);
	
	/*
	 * Probability that the LM assigns to the sentence s
	 */
	abstract double score(String s);
	
	/*
	 * Log-probability that the LM assigns to the sentence s
	 */
	abstract double logScore(String s);
	
	/*
	 * Log-probability that the LM assigns to the sentences in the dataFile
	 */
	abstract double logScoreFile(String dataFile) throws FileNotFoundException;

}
